Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak > Class Template Reference
Other available functionality » Integer propagators

Argument maximum propagator. More...

`#include <arithmetic.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Copy propagator during cloning.
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function.
virtual void | reschedule (Space &home)
| Schedule function.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, IdxViewArray< VA > &x, VB y)
| Post propagator .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| ArgMax (Space &home, ArgMax &p)
| Constructor for cloning p.
| ArgMax (Home home, IdxViewArray< VA > &x, VB y)
| Constructor for posting.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

IdxViewArray< VA > | x
| Map of index and views.
VB | y
| Position of maximum view (maximal argument).

## Detailed Description

template<class VA, class VB, bool tiebreak>
class Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >

Argument maximum propagator.

Tiebreaking is used if tiebreak is true and views can be shared if shread is true.

Requires

#include <gecode/int/arithmetic.hh>
arithmetic.hh

Definition at line 260 of file arithmetic.hh.

## Constructor & Destructor Documentation

## ArgMax() [1/2]

template<class VA, class VB, bool tiebreak>

Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::ArgMax | ( | Space & | home,
|  | ArgMax< VA, VB, tiebreak > & | p )

inline protected

Constructor for cloning p.

Definition at line 76 of file argmax.hpp.

## ArgMax() [2/2]

template<class VA, class VB, bool tiebreak>

Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::ArgMax | ( | Home | home,
|  | IdxViewArray< VA > & | x,
|  | VB | y )

inline protected

Constructor for posting.

Definition at line 40 of file argmax.hpp.

## Member Function Documentation

## copy()

template<class VA, class VB, bool tiebreak>

Actor * Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::copy | ( | Space & | home | ) |

virtual

Copy propagator during cloning.

Implements Gecode::Actor.

Definition at line 84 of file argmax.hpp.

## cost()

template<class VA, class VB, bool tiebreak>

PropCost Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function.

Implements Gecode::Propagator.

Definition at line 90 of file argmax.hpp.

## reschedule()

template<class VA, class VB, bool tiebreak>

void Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 96 of file argmax.hpp.

## propagate()

template<class VA, class VB, bool tiebreak>

ExecStatus Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 103 of file argmax.hpp.

## dispose()

template<class VA, class VB, bool tiebreak>

size_t Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 255 of file argmax.hpp.

## post()

template<class VA, class VB, bool tiebreak>

ExecStatus Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::post | ( | Home | home,
|  | IdxViewArray< VA > & | x,
|  | VB | y )

static

Post propagator .

Note that y must be constrained to be in the proper range for the index values in x.

Definition at line 48 of file argmax.hpp.

## Member Data Documentation

## x

template<class VA, class VB, bool tiebreak>

IdxViewArray<VA> Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::x

protected

Map of index and views.

Definition at line 263 of file arithmetic.hh.

## y

template<class VA, class VB, bool tiebreak>

VB Gecode::Int::Arithmetic::ArgMax< VA, VB, tiebreak >::y

protected

Position of maximum view (maximal argument).

Definition at line 265 of file arithmetic.hh.

The documentation for this class was generated from the following files:

- gecode/int/arithmetic.hh
- gecode/int/arithmetic/argmax.hpp